#!/bin/bash
#Attention ! Ne pas oublier la redirection vers reps, quand on lance le script!!

read url;
read tablo;
echo "j'ai bien lu les reps";


#Tout d'abord on insre le code html pour crer le dbut du tableau avec le code css pour le personnaliser
echo "<html><head><title>tableau de liens</title><style type=\"text/css\">table,th,td {border: 1px solid #333333;text-align: center;} th,td{color:#333333} a {color:#615E39} </style></head><center><body>"> $tablo;

#Cette variable permettra l'indication du n de la page
j=1;

#Pour chacun de nos sous-dossiers : info, nat, ling, socio, on fait une boucle !
for sens in `ls -r $url`
	{
 
	#Ici, le html cre le titre du tableau et ses colonnes
	echo "<table cellspacing="0"><CAPTION><i><font size=14 color=#76C363>$sens</font><i></CAPTION><tr BGCOLOR=#39ACA8><th>"SENS"</th><th>"LIENS"</th><th>"PAGES ASPIREES"</th><th>"DUMP"</th><th>"CONTEXTES"</th></tr>">> $tablo;

	#Pour chaque fichier d'un sous-dossier (espagnol, portugais, franais) on refait une boucle
	for languetxt in `ls $url/$sens`
		{

		#Ce compteur nous indique le nombre de lignes pour chaque langue, c'est--dire le nombre de liens que contient chaque fichier !
		l=0;
		for ligne in `cat $url/$sens/$languetxt`
			{
			let "l=l+1";
			}
		#Et voici la variable "languetxt" sans l'extension ".txt", elle sert  rcuprer le nom de la langue sans l'extension
		langue=$(basename $languetxt .txt);
		
		#insctruction conditionnelle pour que le motif soit soit environnnement soit ambiente, PB!!!!!
			if [ $langue = "franais" ]
			then
			motif="environnement";
			else
			motif="ambiente";
			fi
			echo $motif
			
		#La hauteur (verticale) d'une ligne langue de la colonne sens dpend du nombre d'occurences pour le sens x dans la langue y!   
		echo "<tr><td rowspan=$l BGCOLOR=#C1D559><b>"$langue"<b></td>">> $tablo;

		#On cre un compteur pour stocker les pages cres.
		p=1;

		#Puis, pour chaque lien on refait une boucle afin de remplir les colonnes pages apires, dump et contextes
		for ligne in `cat $url/$sens/$languetxt`;
			{

			# Ici aspire les sites des urls les uns aprs le autres et on les enregistre dans le dossier "PAGES-ASPIREES"
			wget -O ./projet_environnement/PAGES-ASPIREES/$sens$langue$p.html $ligne;

			# Ici on fait un dump du texte (qui permet de rcuprer le texte brut des urls) et  on l'enregistre dans le dossier "DUMP-TEXT"
			lynx -dump -nolist $ligne > ./projet_environnement/DUMP-TEXT/$sens$langue$p.txt;
			
			#permet de rcuprer les contextes contenant le motif et de les rediriger vers le dossir CONTEXTES
			egrep -i "\b"$motif"\b" ./projet_environnement/DUMP-TEXT/$sens$langue$p.txt > ./projet_environnement/CONTEXTES/$sens$langue$p.txt;
			
			#Avec le html,on cre les cellules du tableau permettant de visualiser chaque page cre
			echo "<td><a href=\"$ligne\">lien n $j</a></td><td><a href=\"../PAGES-ASPIREES/$sens$langue$p.html\">page n $j</a></td><td><a href=\"../DUMP-TEXT/$sens$langue$p.txt\">dump n $j</a></td><td><a href=\"../CONTEXTES/$sens$langue$p.txt\">contexte n $j</a></td></tr>" >> $tablo;

			# Le i est incrment de 1 et i revient  1 quand la variable "languetxt" change de valeur
			let "p=p+1";

			#Le j est incrment de 1 galement
			let "j=j+1";
			}
		
			#somme des dumps et contextes par sens et par langue		
			for texte in `ls ./projet_environnement/CONTEXTES/$sens$langue*.txt`; 	## donne la liste des chemins relatifs des fichiers commencent par le sens puis la langue
			{
			cat $texte >> ./projet_environnement/CONTEXTES/contextes_$sens$langue.txt;

			}
			for dump in `ls ./projet_environnement/DUMP-TEXT/*$sens$langue*.txt`; 	
			
			{
			cat $dump >> ./projet_environnement/DUMP-TEXT/dump_$sens$langue.txt;
			
			}
		}
	#Ces deux sauts de ligne permettent de rendre + visible la sparation entre les tableaux
	echo "<br><br>">>$tablo;
	}
#On referme notre tableau et le script est fin prt
echo "</table></center></body></html>" >> $tablo;

