#!/usr/bin/perl 

#on appelle les diffrentes librairies utilises par le script
use strict;
use locale;
use LWP::Simple;
use Encode;
use HTML::Entities;

#on demande  l'utilisateur o sont stockes les urls
print "Entrer un chemin de rpertoire\n";
#on rserve une variable $url pour enregister la rponse de l'utilisateur
my $url =<STDIN>;
#le programme enregistre la rponse
chomp($url);
#on affiche le contenu de la variable $url
print $url;
#on effectue les mmes oprations mais cette fois on demande  l'utilisateur o stocker le tableau final
print "ou stocker le tableau?\n";
my $tablo =<STDIN>;
chomp($tablo);
#ouverture du fichier html contenant le tableau de lien
if (! -e $tablo)
{
		open(SORTIE,">$tablo.html");


#Tout d'abord on insre le code html pour crer le dbut de la page web avec le code css pour la personnaliser
print SORTIE ("<html><head><title>tableau de liens</title><style type=\"text/css\">table,th,td {border: 1px solid #333333;text-align: center;} th,td{color:#333333} a {color:#615E39} </style></head><center><body>");
print SORTIE ("\n");

#Cette variable permettra l'indication du n des pages cres pour les liens, les dumps et les contextes
my $p=1;
#ouverture du rpertoire contenant les url
opendir (REP1, $url) or die "impossible d'ouvrir le repertoire";
#lecture des entrees d'un repertoire, chaque sous rpertoire est reprsente par une ligne dans la liste @sens
my @sens =grep !/^\./,readdir (REP1);
print @sens;
#pour chaque entre du rpertoire lire les entres (par sens) et les afficher
foreach my $entree (@sens)
		{
			#on cre une variable $sens qui contient le chemin d'accs vers les rpertoires
			#pour chaque sens: linguistique, informatique, naturel et socio-culturel
			# chaque tour de boucle on se trouvera dans un rpertoire diffrent
			my $sens = "$url/$entree\n";
			#on affiche la variable $sens pour vrifier que la boucle fonctionne bien
			print $sens;
			#Ici, le code html cre le titre du tableau et la premire ligne avec le libel des colonnes
			print SORTIE ("<table cellspacing=0><CAPTION><i><font size=14 color=#76C363>$entree</font><i></CAPTION><tr BGCOLOR=#39ACA8><th>SENS</th><th>LIENS</th><th>PAGES ASPIREES</th><th>DUMP</th><th>CONTEXTES</th></tr>");
			print SORTIE ("\n");
			#ouverture du rpertoire contenant les fichier pour chaque sens
			opendir (REP2, $sens) or die "impossible d'ouvrir le rpertoire";
			#rcupration sous forme de liste du contenu de REP2
			my @langue =grep !/^\./,readdir (REP2);
			#pour chaque fichier contenu dans la liste @langue, les instructions suivantes seront effectues:
			foreach my $languetxt (@langue)
				{
					#initialise le compteur du nombre de page qui vont tre aspires pour savoir quelle dimension donner au tableau
					my $l=0;
					#on va rcuprer le nom de la langue sans l'extension txt
					#il faut d'abord calculer l'emplacement du . dans la chane de caractre dans la variable $languetxt
					my $point=index($languetxt,'.');
					#puis on cre la variable langue en utilisant la variable languetxt et en ne gardant que ce qui va du premier caractre au .
					my $langue=substr($languetxt,0,$point);
					#affiche la variable langue
					print "$langue\n";
					#on initialise une variable vide pour enregister le motif  chercher dans les pages web
					my $motif =();
					#si la langue est "franais"
					if ($langue eq "franais")
					{
					#le motif est environnement
					$motif = "environnement";
					}
					#sinon dans les deux autres cas (espagnol et portugais)
					else
					{
					#le motif est ambiente
					$motif = "ambiente";
					}
					
					#on donne le chemin d'accs(qui varie en fonction de $url, $entre et $languetxt) 
					#des fichiers dans lequels sont stocks les url 
					my $fichier="$url/$entree/$languetxt";
					#on initialise une liste vide qui va contenir le contenu des lignes de de chaque fichier languetxt
					my @lignes = ();
					#on ouvre le fichier languetxt pour la lecture avec le chevron <
					open (FIC, "<$fichier") || die "fichier non trouv\n"; 
					#tant qu'il y a des lignes dans le fichier on excute les instructions
					while(<FIC>)
					{
					#on envoie le contenu de la ligne $_ dans la liste @lignes
					 push(@lignes,$_);
					#on incrmente la variable $l avant le tour de boucle suivant	
					 $l=$l+1;
					}
					#on remplit la premire colonne de notre tableau (fichier identifi par le nom SORTIE). 
					print SORTIE ("<tr><td rowspan=$l BGCOLOR=#C1D559><b>$langue<b></td>");
					print SORTIE ("\n");
					#pour chaque valeur de la liste @lignes qui vient d'tre construite, on excute le bloc d'instructions:
					foreach my $var (@lignes)
					{	#on cre une variable qui permettra de stocker les pages aspires dans un fichier .html
						my $page_aspi = "perl/PAGES-ASPIREES/$entree$langue$p.html";
						#on ouvre ce fichier pour l'criture avec le chevron >
						open(PAGES,">$page_aspi");
						#on indique dans la variable $ resul o$ l'on stockera les fichiers de contexte
						my $resul="./perl/RESULTAT/$entree$langue$p.txt";
						#on ouvre le fichier de contexte en criture avec >
						open (FIC3, ">$resul")|| die "fichier non trouv\n" ;
						#getstore permet d'aspirer les pages et de les enregistrer directement dans le fichier $page_aspi
						getstore("$var","$page_aspi");
						#la fonction get permet d'aspirer les pages $var et de les stocker dans la variable $page 
						#pour tavailler dessus sans les enregistrer dans un fichier
						my $page = get( "$var" );
						#si la page n'a pas t aspire, un message d'rreur s'affiche
						if ( not defined($page) )
							{
							print "Problme lors du tlchargement !\n";
							#on affecte dans la variable un message d'erreur qui sera affich 
							# la place du contenu de la page (dans le dump)
							$page="La page n'a pas pu tre aspire";
							#on affiche le mme message dans le fichier page aspire
							print PAGES ("La page n'a pas pu tre aspire");
							}
						
						#cette partie du script (qui nettoye les pages) a t ralise avec l'aide d'un script trouv
						#sur le site http://perl.linguistes.free.fr/progs/URL-texte.pl
						#nous l'avons adapt  notre script
						#on va ici reprer l'encodage de la page
						#par dfault on affecte  $encodage_page la valeur "latin1"
						my $codage_page = "latin1";
						if ($page =~ /\bcharset\s*=\s*([\w-]+)/i) 
							{
							$codage_page = $1; 
							#dans $1 est sauvegard le contenu de la premire parenthse de l'expression rgulire
							}	

						# on cherche a savoir si la page est deja en utf8 ou non avec un booleen
						my $testutf8 = utf8::is_utf8($page);
						#on initialise une variable vide pour enregistrer le contenu de la page en unicode
						my $page_unicode=();
						#si on est dj un utf8, on n'a pas besoin de dcoder la page
							if ($testutf8) 
							{
							print "on est en utf8 pas de decodage necessaire\n";
							$page_unicode = $page;
							}
						#sinon on va recoder  l'aide de la fonction decode ( l'aide de la bibliothque Enccode 
						#qui est appele au dbut du script
						else {
							print "on est pas en utf8, il faut donc decoder\n";
							$page_unicode = decode( $codage_page, $page );
							}
						
						#on utilise ici les sous programmes supprime html (pour supprimer les balises, retours  la lignes...)
						my $texte_unicode = supprime_html( $page_unicode );
						#on utilise le sous programme normalise_latin1, pour normailiser les caractres
						my $texte = normalise_latin1( $texte_unicode );
						
						#on intgre ici les sous-programmes  utiliser
						sub supprime_html 
							{ 
							
							my @balises_a_ignorer =
							 ("applet","code","embed","head","object","script","server");

							my $html = shift @_; 
							$html =~ s/\n+/ /g;
							$html =~ s/\r+/ /g;

							decode_entities($html);
							
							foreach my $balise (@balises_a_ignorer) 
								{
							$html=~s/<$balise.*?<\/$balise>//ig;
								}

							$html =~ s/<!--.*?-->//g;     #commentaires
							$html =~ s/<\/?p\/?>/\n/ig;   #paragraphes
							$html =~ s/<br\/?>/\n/ig;     #retours  la ligne
							$html =~ s/<\/tr>/\n/ig;      #lignes de tableau
							$html =~ s/<\/?h[1-6]>/\n/ig; #titres
							$html =~ s/<\/?div.*?>/\n/ig; #sections
							
							$html =~ s/<.*?>//g;          #autres balises
							$html =~ s/\s*\n\s*/\n/g;     #espaces en dbut/fin de ligne
							$html =~ s/ +/ /g;            #squences de plusieurs espaces  

							return $html;
							}

						sub normalise_latin1 
							{
							my $chaine = shift @_;
							$chaine =~ s/[\x{2019}\x{2018}]/\'/g;
							$chaine =~ s/[\x{201C}\x{201D}]/\"/g;
							$chaine =~ s/[\x{2013}\x{2014}]/-/g;
							$chaine =~ s/\x{2026}/.../g;
							$chaine =~ s/\x{0152}/OE/g;
							$chaine =~ s/\x{0153}/oe/g;
							$chaine =~ s/[^\x{0000}-\x{00FF}]//g;
							return $chaine;
							}
						
					#on indique maintenant le chemin d'accs pour stocker les dumps
					my $dump="perl/DUMP/$entree$langue$p.txt";
					#on ouvre le fichier $dump  l'criture avec >
					open(TEXTE,">$dump");
					#on le remplit avec la variable $texte qui contient les pages aspire nettoyes  l'aide de nos sous-programmes
					print TEXTE ("$texte");	
					#on ferme le fichier
					close(TEXTE);
					#on initialise une liste vide pour stocker le contenu des lignes
					my @ligne = ();
					#on ouvre  nouveau le fichier $dump mais cette fois  la lecture avec <
					open (TEXTE, "<$dump") || die "fichier non trouv\n"; 
					#tant qu'il y a des lignes dans le fichier:
					while (<TEXTE>)
					{
					#on enregistre le contenu $_ de la ligne dans la liste @ligne
					#on obtient donc une liste contenant toutes les lignes du fichier
					push(@ligne,$_);	
					}
					
					#on ouvre le fichier $rsul (initialis plus haut)  l'criture
					open (FIC3, ">$resul")|| die "fichier non trouv\n" ;
					#pour chaque ligne de la liste @ligne on fait:						
					foreach my $lin (@ligne)
					{
					#avec la fonction split, on dcoupe les mots de chaque ligne
					#on obtient dans la liste @mots la liste des mots 
					my @mots = split /[\s']/,$lin;            
					#on affiche la liste des mots
					print "$_\n" for @mots;
					#on initialise un conteur qui va permettre de savoir  quel mot on se situe dans la liste @mots
					my $nbre=0;
					#pour chaque mot de la liste @mots:
						foreach my $m (@mots)
						{	#si le mot est gal au motif
							if ($m eq $motif)
							{ 	#on va copier le mot identifi par son idice dans la liste de mots ($mots[$nbre])
								#ainsi que son contexte gauche($mots[$nbre-2]) et droit ($mots[$nbre+2]) dans le fichier de contexte
								#on peur choisir le nombre de mots que l'on veut avoir dans le contexte gauche et droit 
								#on choisit ici deux prendre deux mots  gauche et deux mots  droite
								print FIC3 ("$mots[$nbre-2] $mots[$nbre] $mots[$nbre+2] ");
							}
						# la fin du tour de boucle on incrmente la variable $nbre pour passer au mot suivant
						$nbre=$nbre+1;
						}

					}
					#on ferme le fichier de contexte
					close (FIC3);
					# On edite le code HTML permettant de crer les colonnes du tableau avec les liens
					print SORTIE ("<td><a href=\"$var\">lien n $p</a></td><td><a href=\"./PAGES-ASPIREES/$entree$langue$p.html\">page n $p</a></td><td><a href=\"./DUMP/$entree$langue$p.txt\">dump n $p</a></td><td><a href=\"./RESULTAT/$entree$langue$p.txt\">contexte n $p</a></td></tr>");
					print SORTIE ("\n");
					#on incrmente $p pour passer  la page suivante
					$p=$p+1;
					#on vide la page
					my $page = ();
					#on ferme la page
					close(PAGES);
				}
				#on ferme le fichier de langue pour passer au suivant
				close(FIC);
			}
		#on effectue un saut de ligne dans notre tableau pour passer au fichier suivant		
		print SORTIE ("<br><br>");
		}
#on ferme le tableau
print SORTIE ("</table></center></body></html>");
#on ferme le fichier html contenant le tableau
close(SORTIE);
#on ferme le rpertoire contenant les fichiers par sens
closedir(REP1);
#on ferme le rpertoire url
closedir(REP2);
}